#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <newt.h>
#include <sys/socket.h>
#include <netinet/in.h>


static int width, height;
static int ports[64];
static int portct=0;

static int Wizard(char *title, char *body, char *o1, char *o2, char *o3)
{
	char *p;
	char *w;
	char *b;
	int i=0;
	int j=0;
	
	newtComponent form, label[5], buttons[3], pb=NULL, ok;
	
	newtCenteredWindow(64, 18, title);
	
	form=newtForm(NULL, NULL, 0);

	p=strdup(body);
	w=p;
	b=p;
	
	while(1)
	{
		if(*w=='\n' || *w==0)
		{
			char e=*w;
			*w=0;
			label[i]=newtLabel(2, 3+i, b);
			newtFormAddComponent(form, label[i]);
			b=w+1;
			i++;
			if(!e)
				break;
		}
		w++;
	}

	for(j=0;j<3;j++)
		buttons[j]=0;
		
	if(o1)
		pb=buttons[0]=newtRadiobutton(20, 6+i, o1, 1, pb);
	if(o2)
		pb=buttons[1]=newtRadiobutton(20, 7+i, o2, 0, pb);
	if(o3)
		pb=buttons[2]=newtRadiobutton(20, 8+i, o3, 0, pb);
	
	for(j=0;j<3;j++)
	{
		if(buttons[j])
			newtFormAddComponent(form, buttons[j]);
	}
	
	ok=newtButton(26, 14, "  OK  ");
	newtFormAddComponent(form, ok);
	
	newtRunForm(form);
	
	for(i=0;i<3;i++)
	{
		if(newtRadioGetCurrent(buttons[0])==buttons[i])
			break;
	}
	newtFormDestroy(form);
	
	return i;
}
	

static int Service(char *name, int port, char *data)
{
	int s=socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(s!=-1)
	{
		struct sockaddr_in sin;
		sin.sin_port = htons(port);
		sin.sin_addr.s_addr = htonl(0x7F000001);
		sin.sin_family = AF_INET;
		
		if(connect(s, (struct sockaddr *)&sin, sizeof(sin))==-1)
		{
			close(s);
			return 0;
		}
	}
	if(Wizard(name, data, "   Yes   ", "   No    ", NULL)==0)
	{
		ports[portct++]=port;
		return 0;
	}
	return 1;
}

static int has_device(char *name)
{
	FILE *f=fopen("/proc/net/dev", "r");
	char buf[512];
	int l=strlen(name);
	char *bp;
	
	while(fgets(buf,512,f)!=NULL)
	{
		bp=buf;
		while(*bp==' ')
			bp++;
		if(strncmp(bp, name, l)==0 && bp[l]==':')
		{
			fclose(f);
			return 1;
		}
	}
	fclose(f);
	return 0;
}

void main(int argc, char *argv[])
{
	newtComponent form, button;
	newtComponent label[5];
	
	int security, trustether=1, enable, trustether1=1;
	
	newtInit();
	newtCls();
	
	newtGetScreenSize(&width, &height);
	
	newtCenteredWindow(40,15, "Welcome To Lokkit");
	
	label[0]=newtLabel(14,2, "Lokkit 0.0.5");
	label[1]=newtLabel(11,4, "(C) 1999 Alan Cox");
	label[3]=newtLabel(15,7, "No Warranty");

	button = newtButton(15, 11, "   OK  ");
	form=newtForm(NULL, NULL, 0);
	newtFormAddComponents(form, button, label[0], label[1], label[3], NULL);
	
	newtRunForm(form);
	newtFormDestroy(form);
	newtPopWindow();
	
	security = Wizard("Basic Configuration",
	"Lokkit can set up either a low or high security\n"
	"configuration. A high security configuration blocks all\n"
	"incoming accesses but requires you use specific ftp\n"
	"configurations and blocks irc dcc. The lower security\n"
	"option blocks system services but is not so intrusive.",
		"High Security - more intrusive",
		"Low Security  - less intrusive",
		NULL);
		
	if(has_device("eth0"))
	{
		trustether = Wizard("Local Hosts",
	"You seem to have an ethernet attached to your machine.\n"
	"Shall I trusts the hosts that are connected via this card.\n"
	"If this connection is your link to the internet (eg cable\n"
	"modem) you should say no.",
			"   Yes   ",
			"   No    ",
			NULL);
	}
	else
		trustether = 0;
	
	if(has_device("eth1"))
	{
		trustether1 = Wizard("Local Hosts",
	"You seem to have a second ethernet attached to your machine.\n"
	"Shall I trusts the hosts that are connected via this card.\n"
	"If this connection is your link to the internet (eg cable\n"
	"modem) you should say no.",
			"   Yes   ",
			"   No    ",
			NULL);
	}
	else
		trustether1 = 0;
		
	enable = Wizard("Services",
	"You can enable access to some of the incoming services\n"
	"on your machine. Before doing so you should check you\n"
	"are up to date with any errata from your Linux vendor.\n"
	"Do you wish to select services to enable.\n",
		"   Yes   ",
		"   No    ",
		NULL);
		
	if(enable==0)
	{
		Service("Web Server", 80,
	"This allows people to access and view the web server on\n"
	"your computer. You do not need to enable this to use the\n"
	"web server directly from the machine itself for things\n"
	"like developing pages.");	
		Service("Incoming Mail", 25,
	"Allow incoming SMTP mail delivery. You do not need to enable\n"
	"this if you collect your mail from your ISP's server by POP3\n"
	"or IMAP, or if you use a tool such as fetchmail.");
		Service("Secure Shell", 22,
	"Allow incoming secure shell access. This is an encrypted\n"
	"way to talk to your computer over the internet. You may\n"
	"also wish to read the ssh documentation and set up a list\n"
	"of hosts permitted to connect.");
		Service("Telnet", 23, 
	"Allow incoming telnet accesss. This allows access to the\n"
	"command line shell of the machine from outside, if you\n"
	"have a username and password. It is not encrypted and can\n"
	"therefore be spied up. If possible avoid enabling this.");
	}
	write_firewall(security, trustether, trustether1, ports, portct);
	newtFinished();
}
